###################################################
### chunk number 1: preliminaries
###################################################
#line 81 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
library("ReacTran")
options(prompt = "> ")
options(width=75)


###################################################
### chunk number 2: 
###################################################
#line 241 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
 (grid <- setup.grid.1D(L = 100, dx.1 = 1, N = 50))


###################################################
### chunk number 3: Grid
###################################################
#line 245 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
 plot(grid)


###################################################
### chunk number 4: grid
###################################################
#line 251 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
#line 245 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw#from line#251#"
 plot(grid)
#line 252 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"


###################################################
### chunk number 5: 
###################################################
#line 295 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
grid <- setup.grid.1D(L = 10, N = 100)
Db   <- setup.prop.1D(func = p.exp, grid = grid, 
                      y.0 = 5, y.inf = 0, x.L = 2)


###################################################
### chunk number 6: 
###################################################
#line 307 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
exp.inc <- function(x, y.0 = 1, y.inf = 0.5, x.L = 0, x.att = 1)
       return(1 - p.exp(x, y.0, y.inf, x.L, x.att))

VFsolid <- setup.prop.1D(func = exp.inc, grid = grid, y.0 = 0.9, y.inf = 0.7)


###################################################
### chunk number 7: prop
###################################################
#line 318 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
par(mfrow = c(1, 2))
plot(VFsolid, grid, xyswap = TRUE, type = "l", main = "1-porosity")
plot(Db, grid, xyswap = TRUE, type = "l", main = "Db")
par(mfrow = c(1, 1))


###################################################
### chunk number 8: prop
###################################################
#line 328 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
#line 318 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw#from line#328#"
par(mfrow = c(1, 2))
plot(VFsolid, grid, xyswap = TRUE, type = "l", main = "1-porosity")
plot(Db, grid, xyswap = TRUE, type = "l", main = "Db")
par(mfrow = c(1, 1))
#line 329 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"


###################################################
### chunk number 9: 
###################################################
#line 403 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
tran.1D(C = 1:20, D = 0, flux.up = 1, v = 1, dx = 1)
tran.1D(C = 1:20, D = 0, flux.up = 1, v = 1, dx = 1, full.output = TRUE)


###################################################
### chunk number 10: 
###################################################
#line 438 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
parms <- c(F0 = 1, v = 1, k = 0.1, dx = 1)


###################################################
### chunk number 11: 
###################################################
#line 441 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
advModel <- function(t, C, parms) {
    
   with (as.list(parms), {

     Tran <- tran.1D(C = C, D = 0, flux.up = F0, v = v, dx = dx)
     Consumption <-  k*C
     dC   <- Tran$dC - Consumption
        
     return (list(dC = dC, Consumption= Consumption,
                  flux.up = Tran$flux.up, flux.down = Tran$flux.down))
      })

    }


###################################################
### chunk number 12: 
###################################################
#line 471 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
out <- steady.1D(func = advModel, y = runif(25), parms = parms,
                 nspec = 1, positive = TRUE)


###################################################
### chunk number 13: 
###################################################
#line 494 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
out


###################################################
### chunk number 14: st1
###################################################
#line 498 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
plot (out, xlab = "x", ylab = "Conc", main = "advection")


###################################################
### chunk number 15: figst1
###################################################
#line 505 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
#line 498 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw#from line#505#"
plot (out, xlab = "x", ylab = "Conc", main = "advection")
#line 506 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"


###################################################
### chunk number 16: 
###################################################
#line 527 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
with (out, print(sum(Consumption)-(flux.up-flux.down)))


###################################################
### chunk number 17: 
###################################################
#line 541 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"

Aggregate.Model <- function(time, O2, pars) {

  tran <- tran.1D(C = O2, C.down = C.ow.O2,
                  D = D.grid, A = A.grid,
                  VF = por.grid, dx = grid )

  reac <- - R.O2*(O2/(Ks+O2))
  return(list(dCdt = tran$dC + reac, reac = reac,
              flux.up = tran$flux.up, flux.down = tran$flux.down))
}


###################################################
### chunk number 18: 
###################################################
#line 556 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
C.ow.O2 <- 0.25     # concentration O2 water [micromol cm-3]
por     <- 0.8      # porosity
D       <- 400      # diffusion coefficient O2 [cm2 yr-1]
v       <- 0        # advective velocity [cm yr-1]
R.O2    <- 1000000  # O2 consumption rate [micromol cm-3 yr-1]
Ks      <- 0.005    # O2 saturation constant [micromol cm-3]


###################################################
### chunk number 19: 
###################################################
#line 565 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
R <- 0.025           # radius of the agggregate [cm]
N <- 100             # number of grid layers

grid <- setup.grid.1D(x.up = 0, L = R, N = N)


###################################################
### chunk number 20: 
###################################################
#line 573 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
por.grid <- setup.prop.1D(value = por, grid = grid)
D.grid <- setup.prop.1D(value = D, grid = grid)


###################################################
### chunk number 21: 
###################################################
#line 585 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
sphere.surf <- function (x)   4*pi*x^2

A.grid  <- setup.prop.1D(func = sphere.surf, grid = grid)


###################################################
### chunk number 22: 
###################################################
#line 592 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
O2.agg <- steady.1D (y = runif(N), func = Aggregate.Model, nspec = 1,
                     positive = TRUE, atol = 1e-10)


###################################################
### chunk number 23: agg
###################################################
#line 598 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
plot(O2.agg, grid = grid$x.mid, xlab = "distance from centre, cm", 
     ylab = "mmol/m3", 
     main = "Diffusion-reaction of O2 in a spherical aggregate")


###################################################
### chunk number 24: figagg
###################################################
#line 607 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
#line 598 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw#from line#607#"
plot(O2.agg, grid = grid$x.mid, xlab = "distance from centre, cm", 
     ylab = "mmol/m3", 
     main = "Diffusion-reaction of O2 in a spherical aggregate")
#line 608 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"


###################################################
### chunk number 25: 
###################################################
#line 622 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
  O2.agg$flux.up
  O2.agg$flux.down


###################################################
### chunk number 26: 
###################################################
#line 634 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
 Volume <- A.grid$mid * grid$dx
(Consump <- - sum(O2.agg$reac * Volume * por.grid$mid))


###################################################
### chunk number 27: 
###################################################
#line 640 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
 (Fluxin <- - O2.agg$flux.down * A.grid$int[N+1])


###################################################
### chunk number 28: 
###################################################
#line 646 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
  Consump - Fluxin


###################################################
### chunk number 29: 
###################################################
#line 729 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
river.model <- function (t = 0, OC, pars = NULL)  {

  tran <- tran.volume.1D(C = OC, F.up = F.OC, F.lat = F.lat, 
                         Disp = Disp, flow = flow, V = Volume,
                         full.output = TRUE)
  reac <- - k*OC

  return(list(dCdt = tran$dC + reac,
            F.up = tran$F.up, F.down = tran$F.down,
            F.lat = tran$F.lat))
}


###################################################
### chunk number 30: 
###################################################
#line 745 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
nbox          <- 500                # number of grid cells
lengthEstuary <- 100000             # length of estuary [m]
BoxLength     <- lengthEstuary/nbox # [m]


###################################################
### chunk number 31: 
###################################################
#line 753 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
Distance      <- seq(BoxLength/2, by = BoxLength, len = nbox) # [m]

CrossArea <- 4000 + 72000 * Distance^5 /(Distance^5+50000^5)

Volume  <- CrossArea*BoxLength


###################################################
### chunk number 32: 
###################################################
#line 763 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
Disp    <- 1000   # m3/s, bulk dispersion coefficient
flow    <- 180    # m3/s, mean river flow


###################################################
### chunk number 33: 
###################################################
#line 770 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
F.OC    <- 180               # input organic carbon [mol s-1]
F.lat.0 <- F.OC              # lateral input organic carbon [mol s-1]

k       <- 10/(365*24*3600)  # decay constant organic carbon [s-1]


###################################################
### chunk number 34: 
###################################################
#line 777 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
F.lat <- rep(0, length.out = nbox)


###################################################
### chunk number 35: 
###################################################
#line 783 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
sol  <- steady.1D(y = runif(nbox), fun = river.model, nspec = 1,
                  atol = 1e-15, rtol = 1e-15, positive = TRUE)


###################################################
### chunk number 36: 
###################################################
#line 788 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
F.lat <- F.lat.0*dnorm(x = Distance/lengthEstuary,
                       mean = Distance[nbox/2]/lengthEstuary,
                       sd = 1/20, log = FALSE) /nbox
sol2 <- steady.1D(y = runif(nbox), fun = river.model, nspec = 1, 
                  atol = 1e-15, rtol = 1e-15, positive = TRUE)


###################################################
### chunk number 37: 
###################################################
#line 801 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
summary(sol)
summary(sol2)


###################################################
### chunk number 38: est
###################################################
#line 807 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
plot(sol, sol2, grid = Distance/1000, lwd = 2,
        main = "Organic carbon decay in an estuary",xlab = "distance [km]",
        ylab = "OC Concentration [mM]")
legend ("topright", col = 1:2, lwd = 2, c("baseline", "with lateral input"))


###################################################
### chunk number 39: est
###################################################
#line 816 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
#line 807 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw#from line#816#"
plot(sol, sol2, grid = Distance/1000, lwd = 2,
        main = "Organic carbon decay in an estuary",xlab = "distance [km]",
        ylab = "OC Concentration [mM]")
legend ("topright", col = 1:2, lwd = 2, c("baseline", "with lateral input"))
#line 817 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"


###################################################
### chunk number 40: 
###################################################
#line 826 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
sum(sol$F.up) + sum(sol$F.lat) - sum(sol$F.down) - sum(sol$y*k*Volume)


###################################################
### chunk number 41: 
###################################################
#line 888 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
n     <- 100           # number of grid cells
dy    <- dx <- 100/n   # grid size

Dy    <- Dx <- 5   # diffusion coeff, X- and Y-direction
r     <- -0.02     # production/consumption rate
Bc    <- 300       # boundary concentration
irr   <- 20        # irrigation rate
vx    <- 1         # advection


###################################################
### chunk number 42: 
###################################################
#line 900 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
y  <- matrix(nrow = n, ncol = n, 0)


###################################################
### chunk number 43: 
###################################################
#line 905 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
Diff2D <- function (t, y, parms, N) {

  CONC <- matrix(nrow = N, ncol = N, y)
# Transport
  Tran    <-tran.2D(CONC, D.x = Dx, D.y = Dy, C.y.down = Bc,
                    dx = dx, dy = dy, v.x = vx)

# transport + reaction
  dCONC   <- Tran$dC + r*CONC

# Bioirrigation in a central spot
  mid <- N/2
  dCONC[mid, mid] <- dCONC[mid, mid]  + irr*(Bc - CONC[mid, mid])

  return (list(dCONC))
}


###################################################
### chunk number 44: 
###################################################
#line 935 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
print(system.time(
 std  <- steady.2D(func = Diff2D, y = as.vector(y), time = 0, N = n,
                   parms = NULL, lrw = 1000000, dimens = c(n, n),
                   nout = 0, positive = TRUE)
))


###################################################
### chunk number 45: 
###################################################
#line 943 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
times <- seq(0, 100, 5)
print(system.time(
  out2 <- ode.2D(func = Diff2D, y = as.vector(y), times = times, N = n,
                 parms = NULL, lrw = 10000000, dimens = c(n, n))
))


###################################################
### chunk number 46: twod5
###################################################
#line 952 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
mat <- matrix(nrow = n, ncol = n, subset(out2, time ==  20))
filled.contour(mat, zlim = c(0, Bc), color = femmecol,
               main = "after 20 time units")


###################################################
### chunk number 47: twod
###################################################
#line 964 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
#line 952 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw#from line#964#"
mat <- matrix(nrow = n, ncol = n, subset(out2, time ==  20))
filled.contour(mat, zlim = c(0, Bc), color = femmecol,
               main = "after 20 time units")
#line 965 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"


###################################################
### chunk number 48: twodst
###################################################
#line 973 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
image (std, main = "steady-state", legend = TRUE)


###################################################
### chunk number 49: twodst
###################################################
#line 979 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"
#line 973 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw#from line#979#"
image (std, main = "steady-state", legend = TRUE)
#line 980 "d:/Rcompile/CRANpkg/local/2.12/ReacTran/inst/doc/ReacTran.rnw"


